---
title: Presenter Output
---

### Presenter Output

When accessing the field value from a decorated entry model the an instance of `\Anomaly\ImageFieldType\Image\ImagePresenter` which extends `\Anomaly\FilesModule\File\FilePresenter` will be returned.

###### Example

    $decorated->example->path; // local://folder/file.ext

    $decorated->example->make()->url() }} // /app/{application}/example/image.jpg

###### Twig

    {{ decorated.example.path }} // local://folder/file.ext

    {{ decorated.example.make.url }} // /app/{application}/example/image.jpg

#### ImagePresenter::cropped()

The `cropped` method returns an `Image` instance with the crop data applied.

###### Returns: `\Anomaly\Streams\Platform\Image\Image`

###### Example

    $decorated->example->cropped();

    $decorated->example->cropped()->path();

    $decorated->example->cropped()->widen(100)->path();

###### Twig

    {{ decorated.example.cropped() }}

    {{ decorated.example.cropped().path() }}

    {{ decorated.example.cropped().widen(100).path() }}

